; ****************************************************************************
; TRDOS386.ASM (TRDOS 386 Kernel) - v2.0.0 - vidata.s
; ----------------------------------------------------------------------------
; Last Update: 30/01/2016
; ----------------------------------------------------------------------------
; Beginning: 16/01/2016
; ----------------------------------------------------------------------------
; Assembler: NASM version 2.11 (trdos386.s)
; ----------------------------------------------------------------------------
; Turkish Rational DOS
; Operating System Project v2.0 by ERDOGAN TAN (Beginning: 04/01/2016)
;
; Derived from 'Retro UNIX 386 Kernel - v0.2.1.0' source code by Erdogan Tan
; vidata.inc (11/03/2015)
;
; Derived from 'IBM PC-AT' BIOS source code (1985) 
; ****************************************************************************

; Retro UNIX 386 v1 Kernel - VIDATA.S
; Last Modification: 11/03/2015
;		    (Data section for 'VIDEO.INC')	
;
; ///////// VIDEO DATA ///////////////

;-----	COLUMNS
;M6:
;	db	40, 40, 80, 80, 40, 40, 80, 80

;-----	C_REG_TAB
;M7:
;	db	2Ch, 28h, 2Dh, 29h, 2Ah, 2Eh, 1Eh, 29h	; TABLE OF MODE SETS

;----------------------------------------
;	VIDEO DISPLAY DATA AREA		;
;----------------------------------------
CRT_MODE	db	3	; CURRENT DISPLAY MODE (TYPE)
CRT_MODE_SET	db	29h	; CURRENT SETTING OF THE 3X8 REGISTER
				; (29h default setting for video mode 3)
				; Mode Select register Bits
				;   BIT 0 - 80x25 (1), 40x25 (0)
				;   BIT 1 - ALPHA (0), 320x200 GRAPHICS (1)
				;   BIT 2 - COLOR (0), BW (1)
				;   BIT 3 - Video Sig. ENABLE (1), DISABLE (0)
				;   BIT 4 - 640x200 B&W Graphics Mode (1)
				;   BIT 5 - ALPHA mode BLINKING (1)
				;   BIT 6, 7 - Not Used

; Mode 0 - 2Ch = 101100b	; 40x25 text, 16 gray colors
; Mode 1 - 28h = 101000b	; 40x25 text, 16 fore colors, 8 back colors
; Mode 2 - 2Dh = 101101b	; 80x25 text, 16 gray colors	
; MODE 3 - 29h = 101001b	; 80x25 text, 16 fore color, 8 back color
; Mode 4 - 2Ah = 101010b	; 320x200 graphics, 4 colors
; Mode 5 - 2Eh = 101110b	; 320x200 graphics, 4 gray colors
; Mode 6 - 1Eh = 011110b	; 640x200 graphics, 2 colors
; Mode 7 - 29h = 101001b	; 80x25 text, black & white colors
; Mode & 37h = Video signal OFF
			
video_params:
	; 02/09/2014 (Retro UNIX 386 v1)
	;ORGS.ASM ----- 06/10/85   COMPATIBILITY MODULE
	; VIDEO MODE 3
	db	71h,50h,5Ah,0Ah,1Fh,6,19h	; SET UP FOR 80X25
	db	1Ch,2,7,6,7	; cursor start = 6, cursor stop = 7
	db	0,0,0,0

; 16/01/2016
chr_attrib:  ; Character color/attributes for viode pages (0 to 7)
	db	07h, 07h, 07h, 07h, 07h, 07h, 07h, 07h
; 30/01/2016
vmode:
	db	3,3,3,3,3,3,3,3 ; video modes for pseudo screens 

; /// End Of VIDEO DATA ///